/**
 *  '$RCSfile: EditingCompleteListener.java,v $'
 *  Copyright: 2000 Regents of the University of California and the
 *              National Center for Ecological Analysis and Synthesis
 *    Authors: @authors@
 *    Release: @release@
 *
 *   '$Author: higgins $'
 *     '$Date: 2001/06/29 18:29:13 $'
 * '$Revision: 1.4 $'
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package edu.ucsb.nceas.morpho.framework;

/**
 * Any object that is interested in being notified when editing of
 * an XML document is complete and obtaining a copy of the edited
 * (new) document should implement this interface and register
 * with the editor document
 */
public interface EditingCompleteListener
{
  /**
   * This method is called when editing is complete
   *
   * @param xmlString is the edited XML in String format
   */
  public void editingCompleted(String xmlString, String id, String location);
  
  /**
   * this method handles canceled editing
   */
  public void editingCanceled(String xmlString, String id, String location);
}
